local o=require"luci.model.docker"
local i,t,e
local l=o.new()
i=SimpleForm("docker",translate("Docker - Network"))
i.redirect=luci.dispatcher.build_url("admin","docker","networks")
t=i:section(SimpleSection)
t.template="dockerman/apply_widget"
t.err=o:read_status()
t.err=t.err and t.err:gsub("\n","<br />"):gsub(" ","&#160;")
if t.err then
o:clear_status()
end
t=i:section(SimpleSection,translate("Create new docker network"))
t.addremove=true
t.anonymous=true
e=t:option(Value,"name",
translate("Network Name"),
translate("Name of the network that can be selected during container creation"))
e.rmempty=true
e=t:option(ListValue,"driver",translate("Driver"))
e.rmempty=true
e:value("bridge",translate("Bridge device"))
e:value("macvlan",translate("MAC VLAN"))
e:value("ipvlan",translate("IP VLAN"))
e:value("overlay",translate("Overlay network"))
e=t:option(Value,"parent",translate("Base device"))
e.rmempty=true
e:depends("driver","macvlan")
local a=luci.sys and luci.sys.net and luci.sys.net.devices()or{}
for a,t in ipairs(a)do
e:value(t,t)
end
e=t:option(ListValue,"macvlan_mode",translate("Mode"))
e.rmempty=true
e:depends("driver","macvlan")
e.default="bridge"
e:value("bridge",translate("Bridge (Support direct communication between MAC VLANs)"))
e:value("private",translate("Private (Prevent communication between MAC VLANs)"))
e:value("vepa",translate("VEPA (Virtual Ethernet Port Aggregator)"))
e:value("passthru",translate("Pass-through (Mirror physical device to single MAC VLAN)"))
e=t:option(ListValue,"ipvlan_mode",translate("Ipvlan Mode"))
e.rmempty=true
e:depends("driver","ipvlan")
e.default="l3"
e:value("l2",translate("L2 bridge"))
e:value("l3",translate("L3 bridge"))
e=t:option(Flag,"ingress",
translate("Ingress"),
translate("Ingress network is the network which provides the routing-mesh in swarm mode"))
e.rmempty=true
e.disabled=0
e.enabled=1
e.default=0
e:depends("driver","overlay")
e=t:option(DynamicList,"options",translate("Options"))
e.rmempty=true
e.placeholder="com.docker.network.driver.mtu=1500"
e=t:option(Flag,"internal",translate("Internal"),translate("Restrict external access to the network"))
e.rmempty=true
e:depends("driver","overlay")
e.disabled=0
e.enabled=1
e.default=0
if nixio.fs.access("/etc/config/network")and nixio.fs.access("/etc/config/firewall")then
e=t:option(Flag,"op_macvlan",translate("Create macvlan interface"),translate("Auto create macvlan interface in Openwrt"))
e:depends("driver","macvlan")
e.disabled=0
e.enabled=1
e.default=1
end
e=t:option(Value,"subnet",translate("Subnet"))
e.rmempty=true
e.placeholder="10.1.0.0/16"
e.datatype="ip4addr"
e=t:option(Value,"gateway",translate("Gateway"))
e.rmempty=true
e.placeholder="10.1.1.1"
e.datatype="ip4addr"
e=t:option(Value,"ip_range",translate("IP range"))
e.rmempty=true
e.placeholder="10.1.1.0/24"
e.datatype="ip4addr"
e=t:option(DynamicList,"aux_address",translate("Exclude IPs"))
e.rmempty=true
e.placeholder="my-route=10.1.1.1"
e=t:option(Flag,"ipv6",translate("Enable IPv6"))
e.rmempty=true
e.disabled=0
e.enabled=1
e.default=0
e=t:option(Value,"subnet6",translate("IPv6 Subnet"))
e.rmempty=true
e.placeholder="fe80::/10"
e.datatype="ip6addr"
e:depends("ipv6",1)
e=t:option(Value,"gateway6",translate("IPv6 Gateway"))
e.rmempty=true
e.placeholder="fe80::1"
e.datatype="ip6addr"
e:depends("ipv6",1)
i.handle=function(a,t,e)
if t==FORM_VALID then
local u=e.name
local i=e.driver
local c=e.internal==1 and true or false
local d=e.subnet
local r=e.gateway
local s=e.ip_range
local a={}
local t=e.aux_address or{}
for t,e in ipairs(t)do
_,_,k1,v1=e:find("(.-)=(.+)")
a[k1]=v1
end
local n={}
t=e.options or{}
for t,e in ipairs(t)do
_,_,k1,v1=e:find("(.-)=(.+)")
n[k1]=v1
end
local h=e.ipv6==1 and true or false
local t={
Name=u,
Driver=i,
EnableIPv6=h,
IPAM={
Driver="default"
},
Internal=c
}
if d or r or s then
t["IPAM"]["Config"]={
{
Subnet=d,
Gateway=r,
IPRange=s,
AuxAddress=a,
AuxiliaryAddresses=a
}
}
end
if i=="macvlan"then
t["Options"]={
macvlan_mode=e.macvlan_mode,
parent=e.parent
}
elseif i=="ipvlan"then
t["Options"]={
ipvlan_mode=e.ipvlan_mode
}
elseif i=="overlay"then
t["Ingress"]=e.ingerss==1 and true or false
end
if h and e.subnet6 and e.subnet6 then
if type(t["IPAM"]["Config"])~="table"then
t["IPAM"]["Config"]={}
end
local a=#t["IPAM"]["Config"]
t["IPAM"]["Config"][a+1]={
Subnet=e.subnet6,
Gateway=e.gateway6
}
end
if next(n)~=nil then
t["Options"]=t["Options"]or{}
for a,e in pairs(n)do
t["Options"][a]=e
end
end
t=o.clear_empty_tables(t)
o:write_status("Network: ".."create".." "..t.Name.."...")
local a=l.networks:create({
body=t
})
if a and a.code==201 then
o:write_status("Network: ".."create macvlan interface...")
a=l.networks:inspect({
name=t.Name
})
if i=="macvlan"and
e.op_macvlan~=0 and
a.code==200 and
a.body and
a.body.IPAM and
a.body.IPAM.Config and
a.body.IPAM.Config[1]and
a.body.IPAM.Config[1].Gateway and
a.body.IPAM.Config[1].Subnet then
o.create_macvlan_interface(e.name,
e.parent,
a.body.IPAM.Config[1].Gateway,
a.body.IPAM.Config[1].Subnet)
end
o:clear_status()
luci.http.redirect(luci.dispatcher.build_url("admin/docker/networks"))
else
o:append_status("code:"..a.code.." "..(a.body.message and a.body.message or a.message).."\n")
luci.http.redirect(luci.dispatcher.build_url("admin/docker/newnetwork"))
end
end
end
return i
